import { Item, TriggerCommand } from './types';
export type StringKeyOf<T> = keyof T & string;
export declare function parsePageToken(pageToken: string | undefined): Item | undefined;
export declare function formatPageToken(lastKey: Item | undefined): string | undefined;
export declare function parseRequest(request: any): {
    command: TriggerCommand;
    key: Record<string, any>;
    tableName?: string;
};
export declare function getKeyValues(item: any, keyAttributes: string[]): any[];
export declare function error(message: string): never;
//# sourceMappingURL=utils.d.ts.map